## tpctl 0.8.1

=== Makefile ===

all: compile

include Makefile_common

DIR_TMP=/tmp
DIR_SRC_TPCTL=tpctl-$(VER_TPCTL)
FILE_SRCTAR=tpctl-$(VER_TPCTL).src.tar

compile:
	@for dir in drivers lib tpctl ntpctl; do if ! make -C $$dir all; then exit 1; fi; done
	@echo Compilation complete.

install: uninstall uninstall_legacy install_setup install_modules install_binaries
	depmod -a
	mknod --mode=664 /dev/thinkpad c 10 170
	install -m 644 -o 0 -g 0 tpctl.1 $(DIR_MAN)/man1/tpctl.1
	ln -s $(DIR_MAN)/man1/tpctl.1 $(DIR_MAN)/man1/ntpctl.1

install_setup:
	utils/tpctlify $(DIR_MOD) $(DIR_LIB)

install_modules:
	if [ ! -d $(DIR_MOD)/thinkpad ]; then mkdir -p -m 755 $(DIR_MOD)/thinkpad ; fi
	install -m 444 -o 0 -g 0 drivers/thinkpad.o $(DIR_MOD)/thinkpad/thinkpad.o
	install -m 444 -o 0 -g 0 drivers/smapi.o $(DIR_MOD)/thinkpad/smapi.o
	install -m 444 -o 0 -g 0 drivers/superio.o $(DIR_MOD)/thinkpad/superio.o
	install -m 444 -o 0 -g 0 drivers/rtcmosram.o $(DIR_MOD)/thinkpad/rtcmosram.o

install_binaries:
	if [ ! -d $(DIR_LIB) ]; then mkdir -p -m 755 $(DIR_LIB) ; fi
	install -m 755 -o 0 -g 0 lib/libsmapidev-$(VER_TPCTL).so $(DIR_LIB)/libsmapidev-$(VER_TPCTL).so
	ln -sf $(DIR_LIB)/libsmapidev-$(VER_TPCTL).so $(DIR_LIB)/libsmapidev.so
	if [ ! -d $(DIR_BIN) ]; then mkdir -p -m 755 $(DIR_BIN) ; fi
	install -m 755 -o 0 -g 0 tpctl/tpctl $(DIR_BIN)/tpctl
	install -m 755 -o 0 -g 0 ntpctl/ntpctl $(DIR_BIN)/ntpctl

uninstall: 
	modprobe -r smapi
	modprobe -r superio
	modprobe -r rtcmosram
	modprobe -r thinkpad
	rm -vrf $(DIR_MOD)/thinkpad
	rm -vf $(DIR_LIB)/libsmapidev.so
	rm -vf $(DIR_LIB)/libsmapidev-*.so
	rm -vf $(DIR_BIN)/tpctl
	rm -vf $(DIR_BIN)/ntpctl
	rm -vf /dev/thinkpad
	rm -vf $(DIR_MAN)/man1/tpctl.1
	rm -vf $(DIR_MAN)/man1/ntpctl.1

uninstall_legacy:
	rm -vrf /lib/modules/thinkpad
	rm -vf /usr/bin/tpctl
	rm -vf /usr/local/bin/smapify_modulesconf
	rm -vf /usr/local/bin/tpctlify_modulesconf
	rm -vf /usr/local/bin/tpctlify
	rm -vf /usr/local/sbin/tpctlify
	rm -vf /dev/tp600
	rm -vf /dev/smapi

depend:

clean:
	@for dir in drivers lib tpctl ntpctl other_tools/* ; do make -C $$dir clean ; done
	@echo Cleaning complete.

tarball: clean
	rm -vrf $(DIR_TMP)/$(DIR_SRC_TPCTL)
	mkdir $(DIR_TMP)/$(DIR_SRC_TPCTL)
	cp -vrf AUTHORS README TODO TROUBLESHOOTING VGA_MODES ChangeLog Makefile* drivers lib tpctl ntpctl include utils other_tools tpctl.1 $(DIR_TMP)/$(DIR_SRC_TPCTL)
	rm -vf $(DIR_TMP)/$(FILE_SRCTAR).gz
	sh -c "cd $(DIR_TMP) ; /bin/tar -zcvf $(FILE_SRCTAR).gz $(DIR_SRC_TPCTL)"
	mv -vf $(DIR_TMP)/$(FILE_SRCTAR).gz /usr/src/redhat/SOURCES/tpctl-$(VER_TPCTL).src.tar.gz
	rm -vrf $(DIR_TMP)/$(DIR_SRC_TPCTL)
	@echo Tarball /usr/src/redhat/SOURCES/tpctl-$(VER_TPCTL).src.tar.gz has been created.

=== drivers/Makefile ===

all: thinkpad.o smapi.o superio.o rtcmosram.o

include ../Makefile_common

CFLAGS := -I$(DIR_KERNEL)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX

MODCFLAGS := $(CFLAGS) -O -DMODULE -D__KERNEL__


thinkpad.o: thinkpad.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/thinkpad.h
	$(CC) $(MODCFLAGS) -o $@ -c thinkpad.c

smapi.o: smapi_core.o smapi_call.o
	ld -r $^ -o $@ 

smapi_core.o: smapi_core.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/smapi.h ../include/smapi_call.h
	$(CC) $(MODCFLAGS) -o $@ -c smapi_core.c

smapi_call.o: smapi_call.s
	$(CC) $(MODCFLAGS) -o $@ -c smapi_call.s

superio.o: superio.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/superio.h
	$(CC) $(MODCFLAGS) -o $@ -c superio.c

rtcmosram.o: rtcmosram.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/rtcmosram.h
	$(CC) $(MODCFLAGS) -o $@ -c rtcmosram.c

clean:
	rm -vf *.o

=== lib/Makefile ===

all: libsmapidev.so

include ../Makefile_common

CFLAGS := -I$(DIR_KERNEL)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX
#-DDEBUG_REGS
#-DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM


libsmapidev.so: smapidev.o
	ld -shared -o libsmapidev-$(VER_TPCTL).so smapidev.o
	ln -sf libsmapidev-$(VER_TPCTL).so libsmapidev.so

smapidev.o: smapidev.c ../include/thinkpad_common.h ../include/thinkpad.h ../include/smapi.h ../include/smapidev.h
	$(CC) $(CFLAGS) -o $@ -c smapidev.c

clean:
	rm -vf *.o *.so

=== ntpctl/Makefile ===

all: ntpctl

include ../Makefile_common

CFLAGS := -I$(DIR_KERNEL)/include -I../include -L../lib -Wall -Wcast-align -Wstrict-prototypes -DLINUX

ntpctl: ntpctl.o event_cond.o pointing_device.o timer.o ../lib/libsmapidev.so
	$(CC) $(CFLAGS) -o $@ -lsmapidev -lncurses -lmenu ntpctl.o event_cond.o pointing_device.o timer.o

event_cond.o: event_cond.c ntpctl.h ../include/thinkpad_common.h ../include/smapi.h
	$(CC) $(CFLAGS) -o $@ -c event_cond.c

pointing_device.o: pointing_device.c ntpctl.h
	$(CC) $(CFLAGS) -o $@ -c pointing_device.c

timer.o: timer.c ntpctl.h
	$(CC) $(CFLAGS) -o $@ -c timer.c

ntpctl.o: ntpctl.c ntpctl.h
	$(CC) $(CFLAGS) -o $@ -c ntpctl.c

clean:
	rm -vf ntpctl core *.o

=== tpctl/Makefile ===

all: tpctl

include ../Makefile_common

CFLAGS := -I$(DIR_KERNEL)/include -I../include -L../lib -Wall -Wcast-align -Wstrict-prototypes -DLINUX -DVIAGRA
#-DDEBUG_REGS
#-DALLOW_POWEROFF
#-DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM
#-DTP570_KLUDGE

tpctl: tpctl.o ../lib/libsmapidev.so
	$(CC) $(CFLAGS) -o $@ -lsmapidev -lncurses tpctl.o

tpctl.o: tpctl.c ../include/thinkpad_common.h ../include/thinkpad.h ../include/smapi.h ../include/superio.h ../include/rtcmosram.h ../include/smapidev.h
	$(CC) $(CFLAGS) -o $@ -c tpctl.c

clean:
	rm -vf tpctl core *.o

=== other_tools/tpctlir/Makefile ===
all: tpctlir

include ../../Makefile_common

CFLAGS := -I$(DIR_KERNEL)/include -Wall -Wcast-align -Wstrict-prototypes -O2 -DLINUX


tpctlir: tpctlir.c
	$(CC) $(CFLAGS) -o tpctlir tpctlir.c

clean:
	rm -vf tpctlir core *.o

install:
	install -m 755 -o 0 -g 0 tpctlir $(DIR_SBIN)/tpctlir

uninstall:
	rm -vf $(DIR_SBIN)/tpctlir

=== other_tools/ubswap/Makefile ===

all: hdparm

include ../../Makefile_common

CFLAGS := -I$(DIR_KERNEL)/include -O2 -Wall -Wcast-align -Wstrict-prototypes -DLINUX
 
hdparm: hdparm.c 
	$(CC) $(CFLAGS) -s -o hdparm hdparm.c
 
install: all 
	if [ -f /sbin/hdparm ]; then mv -fv /sbin/hdparm /sbin/hdparm-old ; fi 
	if [ -f /usr/sbin/hdparm ]; then mv -fv /usr/sbin/hdparm /usr/sbin/hdparm-old ; fi 
	if [ -f /usr/local/bin/hdparm ]; then mv -fv /usr/local/bin/hdparm /usr/local/bin/hdparm-old ; fi 
	if [ -f /usr/local/sbin/hdparm ]; then mv -fv /usr/local/sbin/hdparm /usr/local/sbin/hdparm-old ; fi 
	if [ -f /usr/local/sbin/idectl ]; then rm -fv /usr/local/sbin/idectl ; fi
	if [ -f /usr/local/sbin/ultrabayd ]; then rm -fv /usr/local/sbin/ultrabayd ; fi
	install -m 755 -o root -g root hdparm /sbin
	install -m 755 -o root -g root idectl $(DIR_SBIN)
	install -m 755 -o root -g root ultrabayd $(DIR_SBIN)

uninstall:
	rm -vf /sbin/hdparm
	rm -vf $(DIR_SBIN)/idectl
	rm -vf $(DIR_SBIN)/ultrabayd

clean:
	rm -vf hdparm core *.o

## tpctl 3.4

=== Makefile ===

all: 
	make -C lib
	make -C tpctl
	make -C ntpctl

VER_RELEASE=3.4
VER_SMAPIDEV=1.0

DIR_SBIN=/usr/sbin
DIR_BIN=/usr/bin
DIR_LIB=/usr/lib
DIR_MAN=/usr/share/man
DIR_TMP=/tmp
DIR_SRC=tpctl-$(VER_RELEASE)
FILE_TARBALL=tpctl_$(VER_RELEASE).tar.gz

install: uninstall install_libraries install_binaries install_man

install_libraries:
	if [ ! -d $(DIR_LIB) ]; then mkdir -p -m 755 $(DIR_LIB) ; fi
	install -m 755 -o 0 -g 0 lib/libsmapidev.so.$(VER_SMAPIDEV) $(DIR_LIB)
	ln -sf libsmapidev.so.$(VER_SMAPIDEV) $(DIR_LIB)/libsmapidev.so.1

install_binaries:
	if [ ! -d $(DIR_BIN) ]; then mkdir -p -m 755 $(DIR_BIN) ; fi
	install -m 755 -o 0 -g 0 tpctl/tpctl $(DIR_BIN)/tpctl
	install -m 755 -o 0 -g 0 ntpctl/ntpctl $(DIR_BIN)/ntpctl
	if [ -e tpctlir/tpctlir ]; then install -m 755 -o 0 -g 0 tpctlir/tpctlir $(DIR_SBIN)/tpctlir ; fi
	install -m 755 -o 0 -g 0 apmiser/apmiser $(DIR_SBIN)/apmiser

install_man:
	install -m 644 -o 0 -g 0 man/tpctl.1 $(DIR_MAN)/man1/tpctl.1
	install -m 644 -o 0 -g 0 man/ntpctl.1 $(DIR_MAN)/man1/ntpctl.1

uninstall: uninstall_legacy uninstall_libraries uninstall_binaries uninstall_man

uninstall_libraries:
	rm -vf $(DIR_LIB)/libsmapidev.so*

uninstall_binaries:
	rm -vf $(DIR_BIN)/tpctl
	rm -vf $(DIR_BIN)/ntpctl
	rm -vf $(DIR_SBIN)/tpctlir
	rm -vf $(DIR_SBIN)/apmiser

uninstall_man:
	rm -vf $(DIR_MAN)/man1/tpctl.1
	rm -vf $(DIR_MAN)/man1/ntpctl.1

uninstall_legacy:
	@echo Please make sure that the following have been removed:
	@echo '   /usr/local/bin/tpctl'
	@echo '   /usr/local/bin/ntpctl'
	@echo '   /usr/local/sbin/tpctlir'
	@echo '   /usr/local/lib/libsmapidev.so*'
	@echo As of tpctl release 2.x, these programs are installed under /usr instead of /usr/local .

depend:

kdist_clean: clean

clean:
	@for dir in lib tpctl ntpctl ; do make -C $$dir clean ; done
	@echo Cleaning complete.

tarball: clean
	debian/rules clean
	rm -vrf $(DIR_TMP)/$(DIR_SRC)
	mkdir $(DIR_TMP)/$(DIR_SRC)
	cp -vLprf AUTHORS COPYING README TROUBLESHOOTING VGA-MODES SUPPORTED-MODELS ChangeLog Makefile lib tpctl ntpctl include tpctlir apmiser man debian $(DIR_TMP)/$(DIR_SRC)
	chown -R root.root $(DIR_TMP)/$(DIR_SRC)
	rm -vf $(DIR_TMP)/$(FILE_TARBALL)
	sh -c "cd $(DIR_TMP) ; /bin/tar -zcvf $(FILE_TARBALL) $(DIR_SRC)"
	@echo Tarball $(DIR_TMP)/$(FILE_TARBALL) has been created.
	rm -rf $(DIR_TMP)/$(DIR_SRC)

deb:
	debian/rules clean
	debian/rules binary

=== lib/Makefile ===

all: libsmapidev.so

VER_SMAPIDEV=1.0

CFLAGS := -I/usr/include -I../include -Wall -Wcast-align -Wstrict-prototypes -O2 -fPIC -DLINUX
#-DDEBUG_REGS
#-DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM

libsmapidev.so: smapidev.o
	ld -shared -lc -soname libsmapidev.so.1 -o libsmapidev.so.$(VER_SMAPIDEV) smapidev.o
	ln -sf libsmapidev.so.$(VER_SMAPIDEV) libsmapidev.so.1
	ln -sf libsmapidev.so.1 libsmapidev.so

smapidev.o: smapidev.c ../include/thinkpad_common.h ../include/thinkpad.h ../include/smapi.h ../include/smapidev.h
	$(CC) $(CFLAGS) -o $@ -c smapidev.c

clean:
	rm -vf *.o *.so*

=== ntpctl/Makefile ===

all: ntpctl

CFLAGS := -L../lib -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX -O2

ntpctl: ntpctl.o event_cond.o pointing_device.o timer.o ../lib/libsmapidev.so.1
	$(CC) $(CFLAGS) -o $@ ntpctl.o event_cond.o pointing_device.o timer.o -lmenu -lncurses -lsmapidev

event_cond.o: event_cond.c ntpctl.h ../include/thinkpad_common.h ../include/smapi.h
	$(CC) $(CFLAGS) -o $@ -c event_cond.c

pointing_device.o: pointing_device.c ntpctl.h
	$(CC) $(CFLAGS) -o $@ -c pointing_device.c

timer.o: timer.c ntpctl.h
	$(CC) $(CFLAGS) -o $@ -c timer.c

ntpctl.o: ntpctl.c ntpctl.h
	$(CC) $(CFLAGS) -o $@ -c ntpctl.c

clean:
	rm -vf ntpctl core *.o

=== tpctl/Makefile ===

all: tpctl

CFLAGS := -L../lib -I../include -Wall -Wcast-align -Wstrict-prototypes -O2 -Wno-uninitialized -DLINUX
#-DTP570_KLUDGE
#-DALLOW_POWEROFF
#-DDEBUG_REGS -DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM

tpctl: tpctl.o ../lib/libsmapidev.so.1
	$(CC) $(CFLAGS) -o $@ tpctl.o -lncurses -lsmapidev

tpctl.o: tpctl.c ../include/thinkpad_common.h ../include/thinkpad.h ../include/smapi.h ../include/superio.h ../include/rtcmosram.h ../include/smapidev.h
	$(CC) $(CFLAGS) -o $@ -c tpctl.c

clean:
	rm -vf tpctl core *.o

=== tpctlir/Makefile ===
all: tpctlir

CFLAGS := -I$(DIR_KERNEL)/include -Wall -Wcast-align -Wstrict-prototypes -O -DLINUX

DIR_SBIN=/usr/sbin
DIR_MAN=/usr/share/man

tpctlir: tpctlir.c
	$(CC) $(CFLAGS) -o tpctlir tpctlir.c

clean:
	rm -vf tpctlir core *.o

install: uninstall install_binaries install_man

install_binaries:
	install -m 755 -o 0 -g 0 tpctlir $(DIR_SBIN)/tpctlir

install_man:
	install -m 644 -o 0 -g 0 tpctlir.8 $(DIR_MAN)/man8/tpctlir.8

uninstall:
	rm -vf $(DIR_SBIN)/tpctlir
	rm -vf $(DIR_MAN)/man1/tpctlir.1
	rm -vf $(DIR_MAN)/man8/tpctlir.8

## tpctl 4.8

=== Makefile ===

all: 
	make -C lib
	make -C tpctl
	make -C ntpctl

VER_RELEASE:=4.8
VER_SMAPIDEV:=2.0

PATH_SBIN:=/usr/sbin/
PATH_BIN:=/usr/bin/
PATH_LIB:=/usr/lib/
PATH_MAN:=/usr/share/man/
PATH_TMP:=/tmp/
DIR_SRC:=tpctl-$(VER_RELEASE)/
FILE_TARBALL:=tpctl_$(VER_RELEASE).tar.gz

install: uninstall install_libraries install_binaries install_man

install_libraries:
	if [ ! -d $(DEST)$(PATH_LIB) ]; then mkdir -p -m 755 $(DEST)$(PATH_LIB) ; fi
	install -m 755 -o 0 -g 0 lib/libsmapidev.so.$(VER_SMAPIDEV) $(DEST)$(PATH_LIB)
	ln -sf libsmapidev.so.$(VER_SMAPIDEV) $(DEST)$(PATH_LIB)libsmapidev.so.2

install_binaries:
	if [ ! -d $(DEST)$(PATH_BIN) ]; then mkdir -p -m 755 $(DEST)$(PATH_BIN) ; fi
	install -m 755 -o 0 -g 0 tpctl/tpctl $(DEST)$(PATH_BIN)tpctl
	install -m 755 -o 0 -g 0 ntpctl/ntpctl $(DEST)$(PATH_BIN)ntpctl
	if [ -e tpctlir/tpctlir ]; then install -m 755 -o 0 -g 0 tpctlir/tpctlir $(DEST)$(PATH_SBIN)tpctlir ; fi
	if [ ! -d $(DEST)$(PATH_SBIN) ]; then mkdir -p -m 755 $(DEST)$(PATH_SBIN) ; fi
	install -m 755 -o 0 -g 0 apmiser/apmiser $(DEST)$(PATH_SBIN)apmiser

install_man:
	if [ ! -d $(DEST)$(PATH_MAN)man1 ]; then mkdir -p -m 755 $(DEST)$(PATH_MAN)man1 ; fi
	install -m 644 -o 0 -g 0 man/tpctl.1 $(DEST)$(PATH_MAN)man1/tpctl.1
	install -m 644 -o 0 -g 0 man/ntpctl.1 $(DEST)$(PATH_MAN)man1/ntpctl.1

uninstall: uninstall_libraries uninstall_binaries uninstall_man

uninstall_libraries:
	rm -vf $(DEST)$(PATH_LIB)libsmapidev.so*

uninstall_binaries:
	rm -vf $(DEST)$(PATH_BIN)tpctl
	rm -vf $(DEST)$(PATH_BIN)ntpctl
	rm -vf $(DEST)$(PATH_SBIN)tpctlir
	rm -vf $(DEST)$(PATH_SBIN)apmiser

uninstall_man:
	rm -vf $(DEST)$(PATH_MAN)man1/tpctl.1
	rm -vf $(DEST)$(PATH_MAN)man1/ntpctl.1

depend:

kdist_clean: clean

clean:
	@for dir in lib tpctl ntpctl ; do make -C $$dir clean ; done
	@echo Cleaning complete.

tarball: clean
	debian/rules clean
	rm -vrf $(PATH_TMP)$(DIR_SRC)
	mkdir $(PATH_TMP)$(DIR_SRC)
	cp -vLprf AUTHORS COPYING README TROUBLESHOOTING VGA-MODES SUPPORTED-MODELS ChangeLog Makefile tpctl.spec lib tpctl ntpctl include tpctlir apmiser man debian $(PATH_TMP)$(DIR_SRC)
	chown -R root:root $(PATH_TMP)$(DIR_SRC)
	rm -vf $(PATH_TMP)$(FILE_TARBALL)
	sh -c "cd $(PATH_TMP) ; /bin/tar -zcvf $(FILE_TARBALL) $(DIR_SRC)"
	@echo Tarball $(PATH_TMP)$(FILE_TARBALL) has been created.
	rm -rf $(PATH_TMP)$(DIR_SRC)

deb:
	debian/rules clean
	debian/rules binary

=== lib/Makefile ===

all: libsmapidev.so

VER_SMAPIDEV:=2.0

CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2
#-DDEBUG_REGS
#-DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM

ALLCFLAGS:=$(CFLAGS) -I../include -fPIC -DLINUX

libsmapidev.so: smapidev.o
	ld -shared -lc -soname libsmapidev.so.2 -o libsmapidev.so.$(VER_SMAPIDEV) smapidev.o
	ln -sf libsmapidev.so.$(VER_SMAPIDEV) libsmapidev.so.2
	ln -sf libsmapidev.so.2 libsmapidev.so

smapidev.o: smapidev.c ../include/thinkpad_common.h ../include/thinkpad.h ../include/smapi.h ../include/smapidev.h
	$(CC) $(ALLCFLAGS) -o $@ -c smapidev.c

clean:
	rm -vf *.o *.so*

=== ntpctl/Makefile ===

all: ntpctl

CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2

ALLCFLAGS:=$(CFLAGS) -L../lib -I../include -DLINUX

ntpctl: ntpctl.o event_cond.o pointing_device.o timer.o ../lib/libsmapidev.so.2
	$(CC) $(ALLCFLAGS) -o $@ ntpctl.o event_cond.o pointing_device.o timer.o -lmenu -lncurses -lsmapidev

event_cond.o: event_cond.c ntpctl.h ../include/thinkpad_common.h ../include/smapi.h
	$(CC) $(ALLCFLAGS) -o $@ -c event_cond.c

pointing_device.o: pointing_device.c ntpctl.h
	$(CC) $(ALLCFLAGS) -o $@ -c pointing_device.c

timer.o: timer.c ntpctl.h
	$(CC) $(ALLCFLAGS) -o $@ -c timer.c

ntpctl.o: ntpctl.c ntpctl.h
	$(CC) $(ALLCFLAGS) -o $@ -c ntpctl.c

clean:
	rm -vf ntpctl core *.o

=== tpctl/Makefile ===

all: tpctl

CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -Wno-uninitialized -O2
#-DTP570_KLUDGE
#-DALLOW_POWEROFF
#-DDEBUG_REGS -DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM

ALLCFLAGS:=$(CFLAGS) -L../lib -I../include -DLINUX

tpctl: tpctl.o ../lib/libsmapidev.so.2
	$(CC) $(ALLCFLAGS) -o $@ tpctl.o -lncurses -lsmapidev

tpctl.o: tpctl.c ../include/thinkpad_common.h ../include/thinkpad.h ../include/smapi.h ../include/superio.h ../include/rtcmosram.h ../include/smapidev.h
	$(CC) $(ALLCFLAGS) -o $@ -c tpctl.c

clean:
	rm -vf tpctl core *.o

=== tpctlir/Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
 all: tpctlir
 
-CFLAGS := -I$(DIR_KERNEL)/include -Wall -Wcast-align -Wstrict-prototypes -O -DLINUX
+CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2
+
+ALLCFLAGS:=$(CFLAGS) -I$(DIR_KERNEL)/include -DLINUX
 
 DIR_SBIN=/usr/sbin
 DIR_MAN=/usr/share/man

=== debian/changelog ===
tpctl (4.8-1) unstable; urgency=low

  * Tweak tpctl initscript to allow different forms of "yes"
  * Source confmodule in postinst

 -- Thomas Hood <jdthood@yahoo.co.uk>  Fri,  3 Oct 2003 20:39:03 +0200

tpctl (4.7-1) unstable; urgency=low

  * debian/po/nl.po:
    * Add  (Closes: #206514).  Met dank aan cobaco.
  * debian/postinst:
    * try-restart apmiser on upgrade
  * debian/rules:
    * Make use of dh_installinit's new --name option.
      Thanks to Joey Hess for implementing this.
  * debian/control:
    * Build-Depend on debhelper 4.1.68 because of above
    * Standards-Version: 3.6.1  (No changes required)
  * /etc/init.d/tpctl:
    * Create to control sedate-on-lid-closure -- disable it during
      boot and shutdown sequences.  (Closes: #206084)
      Thanks to Andrew Lau for this idea.
  * /etc/default/tpctl:
    * Create to control initscript
  * /usr/sbin/apmiser:
    * Make more intelligent.  New options have been added.
      See the upstream ChangeLog for more details.
      Thanks to wayne schlitt for this work.
  * /etc/init.d/apmiser:
    * Take advantage of the fact that apmiser now generates a pidfile
    * Improve messages and error handling
    * Add "try-restart" option for use by postinst
  * /etc/apm/event.d/apmiser:
    * Create
  * /etc/default/apmiser:
    * Create to control initscript and apm event script
  * apmiser/README
    * Update

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sun, 10 Aug 2003 14:49:33 -0400

tpctl (4.6-1) unstable; urgency=low

  * New upstream with only minor changes
  * Standardized debian copyright file
  * debian/control
    * Standards-Version: 3.6.0  (No changes required)
    * Recommend thinkpad-source (>= 4.0) and thinkpad4-modules
  * Gettextize Debian template.  (Closes: #200553)
    Merci  Michel Grentzinger.
  * Ajouter debian/po/fr.po  (Closes: #200900)
  * Only install apmiser stop rcsymlinks in rc0 and rc6 .
    Now that we use the dh_installinit --start option, invoke-rc.d is
    not called in the postinst, so we do not need to install stop
    rcsymlinks in every runlevel to prevent invoke-rc.d from improperly
    starting apmiser.  (We don't want to start apmiser automatically.
    We leave it up to the administrator to start it manually or to set
    up start rcsymlinks.)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Wed,  9 Jul 2003 08:28:35 +0200

tpctl (4.5-1) unstable; urgency=low

  * New upstream

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sat, 10 May 2003 14:09:16 +0200

tpctl (4.4-1) unstable; urgency=low

  * New upstream
  * Update standards version to 3.5.9:
    * In initscript restart, don't make start dependent on successful
      stop, as per policy.
  * Remove shlibs.local
  * /etc/init.d/apmiser:
    * Print error messages on stderr
    * Exitstatus 3 if arg not recognized

 -- Thomas Hood <jdthood@yahoo.co.uk>  Mon,  7 Apr 2003 21:15:48 +0200

tpctl (4.2-1) unstable; urgency=medium

  * New upstream apmiser.
    Thanks to Dirk Husemann for improving the apmiser script
  * Update description in control file (... mention "IBM" in
    the synopsis and say who should install this package).
  * Add shlibs.local so that we depend on libc6 (>= 2.2.5-11.2)
    and libncurses5 (>= 5.2.20020112a-7), i.e., the woody versions:
        libc 6 libc6 (>= 2.2.5-11.2)
        libncurses 5 libncurses5 (>= 5.2.20020112a-7)
        libmenu 5 libncurses5 (>= 5.2.20020112a-7)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Fri, 17 Jan 2003 10:32:35 +0100

tpctl (4.1-1) unstable; urgency=low

  * Standards-Version: 3.5.8
  * To make linda happy:
      #!/bin/sh -e  =>  #!/bin/sh\nset -e

 -- Thomas Hood <jdthood@yahoo.co.uk>  Wed, 20 Nov 2002 12:00:00 +0100

tpctl (4.0-1) unstable; urgency=high

  * New upstream.  See upstream ChangeLog.
  * Stop apmiser in runlevel 1 (as well as in 0 and 2-6).
  * No --no-restart-on-upgrade option for dh_installinit.
    This switch merely results in the apmiser daemon not being
    stopped in prerm before upgrade.  What we really want is
    the new dh_installinit --no-start option, so ...
  * Add --no-start option to dh_installinit
  * Standards-Version: 3.5.7
  * Use dh_installdebconf before dh_installinit and dh_makeshlibs.
    This ensures that the debconf bit comes before the others in
    the postrm.  Since the debconf bit calls the postrm again,
    it should be the first bit, otherwise the other parts of the
    postrm get executed twice.
  * tpctl now depends on thinkpad-base version 4.0 or later.
    Also add "-V 'tpctl (>= 4.0)'" to dh_makeshlibs.
    This is because we now ship libsmapidev as version 2, in agreement
    with its internal version number.
  * Add "-l$(DEB)/usr/lib" to dh_shlibdeps.  This eliminates a
    warning message from dpkg-shlibdeps that libsmapidev.so.2 cannot
    be found

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sat, 5 Nov 2002 18:00:00 +0200

tpctl (3.7-1) unstable; urgency=low

  * New upstream (with updated docs, added /etc/init.d/apmiser, tweaked
    apmiser and debconf templates)
  * Reword note about thinkpad-modules-x.y.z
  * Add /etc/init.d/apmiser (Closes: #137308) and debconf note to that effect
  * By default, do not start apmiser in any runlevel; but stop apmiser
    on shutdown, so that the machine will boot next time at full speed
  * debian/rules cleanup
  * Add Spanish translation of notes to debconf templates
    -- Thanks to Daniel H. Perez!

 -- Thomas Hood <jdthood@yahoo.co.uk>  Thu, 10 Aug 2002 12:00:00 -0400

tpctl (3.4-1) unstable; urgency=medium

  * Add debconf note about getting a thinkpad-modules-x.y.z package

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sun, 21 Apr 2002 11:00:24 -0400

tpctl (3.3-1) unstable; urgency=medium

  * New upstream
  * Depend on thinkpad-base to make sure that modutils and
    devfs configuration files are available, even if tpctl
    is used with old tpctl-modules-x.y.z packages.
    See bug report #140664.

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sun, 31 Mar 2002 07:37:54 -0500

tpctl (3.2-4) unstable; urgency=low



=== debian/control ===
Source: tpctl
Section: utils
Priority: extra
Maintainer: Thomas Hood <jdthood@yahoo.co.uk>
Build-Depends: debhelper (>= 4.1.68), libncurses5-dev
Standards-Version: 3.6.1.0

Package: tpctl
Architecture: i386
Depends: thinkpad-base (>= 4.0), ${shlibs:Depends}, ${misc:Depends}
Recommends: thinkpad-source (>= 4.0), thinkpad4-modules
Description: IBM ThinkPad hardware configuration tools
 This package contains the ThinkPad Configuration Tools for Linux --
 programs for configuring hardware components in IBM ThinkPad laptop
 computers.  Install this package if and only if your system is an
 IBM ThinkPad.
 .
 The main tpctl program, along with its ncurses variant ntpctl, does
 under Linux some of the things that PS2.EXE does under DOS and the
 ThinkPad Configuration program does under Windows.  The apmiser
 daemon is an intelligent power expenditure controller.
 .
 The programs in the package require some thinkpad driver modules
 package, version 4.0 or later, compatible with the kernel you are
 running.  If there is no such package in the Debian archive, you
 can build one from the thinkpad-source package using the make-kpkg
 utility.  See the README in the thinkpad-base package for more
 information.
 .
 Ideally tpctl would Depend on the thinkpad4-modules virtual package
 and not just Recommend it, because tpctl does need thinkpad driver
 modules in order to do anything useful.  However, because there are
 currently no driver modules packages in the Debian archive, such a
 dependency would make tpctl "uninstallable".  Instead, tpctl
 Depends on thinkpad-base.

=== debian/rules ===
#!/usr/bin/make -f

# To configure in Dutch: LANGUAGE=nl.ISO-8859-15 sudo dpkg-reconfigure tpctl

# This script uses debhelper by Joey Hess
# Portions grabbed from device3dfx-source Copyright (C) 1999 Steve Haslam
export DH_VERBOSE=1
export DH_COMPAT=4
# enables magic below
export DH_OPTIONS

DESTDIR=debian/tpctl
DOC=$(DESTDIR)/usr/share/doc/tpctl

clean:
	dh_testdir
	dh_testroot
	rm -f debian/shlibs
	-$(MAKE) -i clean
#	cd tpctlir && $(MAKE) clean
	dh_clean

build:
	dh_testdir
	$(MAKE)
#	cd tpctlir && $(MAKE)

binary-indep: build

binary-arch: build
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs usr/bin usr/sbin usr/lib etc/default etc/apm/event.d
	install -p -m 755 tpctl/tpctl ntpctl/ntpctl $(DESTDIR)/usr/bin
	install -p -m 755 apmiser/apmiser $(DESTDIR)/usr/sbin
	# .so.x.y is file; .so.x is symlink; .so is symlink in -dev package
	cp -a lib/libsmapidev.so.?.? $(DESTDIR)/usr/lib
	cp -a lib/libsmapidev.so.? $(DESTDIR)/usr/lib
	# Run dh_installdebconf before dh_installinit because the former
	# sources confmodule which restarts the script.
	dh_installdebconf
	# By default do not start apmiser in any runlevel.
	# (Admin can change this later if he or she wishes.)
	dh_installinit --name=tpctl -- start 99 1 2 3 4 5 . stop 01 0 6 .
	dh_installinit --name=apmiser --no-start -- stop 10 0 6 .
	install -p -m 755 debian/tpctl.apmiser.apm-event $(DESTDIR)/etc/apm/event.d/apmiser
	dh_installdocs AUTHORS README TROUBLESHOOTING VGA-MODES
	#	cp tpctlir/tpctlir $(DESTDIR)/usr/sbin
	#	cp tpctlir/README $(DOC)/README.tpctlir
	install -p -m 644 apmiser/README $(DOC)/README.apmiser
	dh_installman man/tpctl.1 man/ntpctl.1 man/apmiser.8
	dh_installchangelogs ChangeLog
	dh_makeshlibs -V 'tpctl (>= 4.0-1)'
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps -l$(DESTDIR)/usr/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary:	binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## tpctl 4.17

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	make -C tpctl
 	make -C ntpctl
 
-VER_RELEASE:=4.8
+VER_RELEASE:=4.14
 VER_SMAPIDEV:=2.0
 
 PATH_SBIN:=/usr/sbin/

=== lib/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 VER_SMAPIDEV:=2.0
 
-CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2
+CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2 -g
 #-DDEBUG_REGS
 #-DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM

=== ntpctl/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 all: ntpctl
 
-CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2
+CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2 -g
 
 ALLCFLAGS:=$(CFLAGS) -L../lib -I../include -DLINUX

=== tpctl/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 all: tpctl
 
-CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -Wno-uninitialized -O2
+CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -Wno-uninitialized -O2 -g
 #-DTP570_KLUDGE
 #-DALLOW_POWEROFF
 #-DDEBUG_REGS -DDEBUG_STRUCT_SIZES -DDEBUG_FILEOPS -DDEBUG_IOPARM

=== tpctlir/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 all: tpctlir
 
-CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2
+CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2 -g
 
 ALLCFLAGS:=$(CFLAGS) -I$(DIR_KERNEL)/include -DLINUX
